\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
iferr(read("recurrence-guess.gp"),e,read("../recurrence-guess.gp"));

{
  for(i=3,10,
     print("i="i);
     print(factor(1-x^i)));
}

{
  my(p=(x^4 - x^3 + x^2 - x + 1));
  p=(1 + x^2)^2;
  p=(1 - x^2)^2;
  p=(1 + x^2);
  p=subst(p,x,x^2);
  p=(1 + x^6);
  p=(1 + x^4);
  p=(1 - x^4 + x^8);
  for(i=1,30,
     print("i="i"   ",(1-x^i) % p));
  print(polroots(p));
}

\\ p is a polynomial.  Return the gcd of the powers which occur.
\\ For example p=x^15+x^9+x^6+1 gives 3.
recurrence_guess_INTERNAL_pol_powers_gcd(p) = \
  gcd(vector(#p,i,i--; if(polcoeff(p,i),i,0)));


recurrence_guess_INTERNAL_pol_is_periodic(p) = 
{
  for(i=1,500, if((1-x^i) % p == 0, return(i)));
  -1;
}

p=1 - x^4 + x^8;
p=subst(p,x,3*x)
recurrence_guess_INTERNAL_pol_is_periodic(p)
recurrence_guess_INTERNAL_gf_terms(1/p, 48)
#v
recurrence_guess_INTERNAL_pol_powers_gcd(p)

\\ print("------------");
\\ p=1 - 2*x^2
\\ g=recurrence_guess_INTERNAL_pol_powers_gcd(p)
\\ p=substpol(p,x^g,x)
\\ p/=2
\\ recurrence_guess_INTERNAL_pol_is_periodic(p)
\\recurrence_guess_INTERNAL_gf_terms(1/p, 48)
\\ recurrence_guess_INTERNAL_pol_is_periodic(p)

p=1 - x^1 + x^2;
p=subst(p,x,3*x)
\\p=subst(p,x,x^4)
recurrence_guess_INTERNAL_pol_period(p)
recurrence_guess_INTERNAL_gf_terms(1/p, 48)
{
  v = [1,0,0,0,
       1,0,0,0
       0,0,0,0,0,
       -1,0,0,0,
       -1,0,0,0
       0,0,0,0,0
      ];
  vector(48,i,i--; 3^floor(i/4)
         * recurrence_guess_INTERNAL_vector_modulo(v,i))
}


\\ den*q = 1-c*x^p
\\ 1/den = q/(1-c*x^p)
\\ num/den = num*q / (1-c*x^p)

\\ num / (1-c*x^p)
\\ vector_modulo(num,n) * c^floor(n/p)

